extends Control

func _process(_delta):
	if get_node("Task/RichTextLabel").text != " ":
		get_node("Complete").visible = true
	else:
		get_node("Complete").visible = false

func _ready():
	get_node("SaveNode").LoadVars("Tasks", 0)
	get_node("SaveNode").LoadVars("Random Task", 1)
	get_node("SaveNode").SaveVars("Random Task", 1)
	
	# load the task into the funny task area
	get_node("Task/RichTextLabel").text = str(get_node("SaveNode").SideVars["Current Task"])
	get_node("Counter/Number").text = str(get_node("SaveNode").SideVars["Amount Completed"])
	
	get_node("AnimationPlayer").play("Beginning")

func _on_random_task_button_pressed():
	if !get_node("AnimationPlayer").is_playing():
		# gained from Tasks_Interface code
		var TempArray = get_node("SaveNode").MainVars.values()
		var random1 = randi_range(0, TempArray.size() - 1)
		var random2 = randi_range(0, TempArray[random1].size() - 1)
		get_node("Task/RichTextLabel").text = TempArray[random1][random2]
		get_node("SaveNode").SideVars["Current Task"] = TempArray[random1][random2]
		get_node("SaveNode").SaveVars("Random Task", 1)

func _on_complete_pressed():
	if !get_node("AnimationPlayer").is_playing():
		# play the win animation, which has some things that happen
		var CompleteAmount = get_node("SaveNode").SideVars["Amount Completed"]
		get_node("Win Particles").amount = (CompleteAmount + 1) * 2
		get_node("Win Particles/Win Particles").amount = (CompleteAmount + 1) * 2
		get_node("AnimationPlayer").play("Win")
		# animation methods: AnimationThingDing

func AnimationThingDing():
	get_node("Task/RichTextLabel").text = " "
	get_node("SaveNode").SideVars["Current Task"] = " "
	# update the amount of stuff completed!
	var CompleteAmount = 1 + get_node("SaveNode").SideVars["Amount Completed"]
	get_node("Counter/Number").text = str(CompleteAmount)
	get_node("SaveNode").SideVars["Amount Completed"] = CompleteAmount
	get_node("SaveNode").SaveVars("Random Task", 1)
